package crmdna.api.servlet;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import crmdna.common.api.APIUtils;
import crmdna.common.api.RequestInfo;
import crmdna.mail2.MailSchedule;
import crmdna.mail2.MailScheduleProp;

import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.util.Date;
import java.util.Map;
import java.util.logging.Level;
import java.util.logging.Logger;

@SuppressWarnings("serial")
public class ScheduledEmailServlet extends HttpServlet {

    private static Gson gson = new GsonBuilder().setPrettyPrinting().create();
    private static final Logger LOG = Logger.getLogger(ScheduledEmailServlet.class.getName());

    protected void doGet(HttpServletRequest request, HttpServletResponse response)
            throws IOException {

        try {
            Date now = new Date();
            Map<String, MailScheduleProp> map = MailSchedule.processFirstScheduledEmailForAllClients(now);

            String result;
            if (map.isEmpty()) {
                result = "No pending email";
            } else {
                result = "Result:\n " + gson.toJson(map);
            }

            LOG.info(result);

            response.setContentType("text/plain");
            response.getWriter().println(result);

        } catch (Exception ex) {
            ex.printStackTrace();
            response.setContentType("text/plain");
            LOG.log(Level.SEVERE, "Exception occured", ex);
            ServletUtils.setJson(response, APIUtils.toAPIResponse(ex, true,
                    new RequestInfo().req(request)));
        }
    }
}
