package crmdna.client.isha;

import crmdna.group.Group;

import java.util.ArrayList;
import java.util.List;

public final class IshaAPAC {

    public static class CountryCfg {
        public String name;
        public String shortName;
        public long groupId;

        CountryCfg(String name, String shortName, long groupId) {
            this.name = name;
            this.shortName = shortName;
            this.groupId = groupId;
        }
    }

    public static final List<CountryCfg> countryCfgs = new ArrayList<>();
    public static long defaultGroupId = 0;

    static {
        long sgGroupId = Group.safeGetByIdOrName("isha", "Isha Singapore").toProp().groupId;
        long hkGroupId = Group.safeGetByIdOrName("isha", "Isha Hong Kong").toProp().groupId;
        long auGroupId = Group.safeGetByIdOrName("isha", "Isha Australia").toProp().groupId;
        long myGroupId = Group.safeGetByIdOrName("isha", "Isha Malaysia").toProp().groupId;
        long aeGroupId = Group.safeGetByIdOrName("isha", "Isha UAE").toProp().groupId;
        long omGroupId = Group.safeGetByIdOrName("isha", "Isha Oman").toProp().groupId;
        long kwGroupId = Group.safeGetByIdOrName("isha", "Isha Kuwait").toProp().groupId;
        long bhGroupId = Group.safeGetByIdOrName("isha", "Isha Bahrain").toProp().groupId;
        long qaGroupId = Group.safeGetByIdOrName("isha", "Isha Qatar").toProp().groupId;

        defaultGroupId = sgGroupId;

        countryCfgs.add(new CountryCfg("UAE", "AE", aeGroupId));
        countryCfgs.add(new CountryCfg("Kuwait", "KW", kwGroupId));
        countryCfgs.add(new CountryCfg("Oman", "OM", omGroupId));
        countryCfgs.add(new CountryCfg("Qatar", "QA", qaGroupId));
        countryCfgs.add(new CountryCfg("Bahrain", "BH", bhGroupId));

        countryCfgs.add(new CountryCfg("Singapore", "SG", sgGroupId));
        countryCfgs.add(new CountryCfg("South Korea", "KR", sgGroupId));
        countryCfgs.add(new CountryCfg("Thailand", "TH", sgGroupId));
        countryCfgs.add(new CountryCfg("Taiwan", "TW", sgGroupId));
        countryCfgs.add(new CountryCfg("Sri Lanka", "LK", sgGroupId));
        countryCfgs.add(new CountryCfg("Vietnam", "VN", sgGroupId));
        countryCfgs.add(new CountryCfg("Cambodia", "KH", sgGroupId));
        countryCfgs.add(new CountryCfg("Philippines", "PH", sgGroupId));
        countryCfgs.add(new CountryCfg("Indonesia", "ID", sgGroupId));

        countryCfgs.add(new CountryCfg("Hong Kong", "HK", hkGroupId));
        countryCfgs.add(new CountryCfg("Malaysia", "MY", myGroupId));
        countryCfgs.add(new CountryCfg("Australia", "AU", auGroupId));
        countryCfgs.add(new CountryCfg("New Zealand", "NZ", auGroupId));
    }

    public static boolean isCountryPresent(String country) {
        for (IshaAPAC.CountryCfg cty : IshaAPAC.countryCfgs) {
            if (cty.name.equalsIgnoreCase(country) || cty.shortName.equalsIgnoreCase(country)) {
                return true;
            }
        }

        return false;
    }

    public static String getCountryCode(String countryName) {
        for (IshaAPAC.CountryCfg cty : IshaAPAC.countryCfgs) {
            if (cty.name.equalsIgnoreCase(countryName)) {
                return cty.shortName;
            }
        }
        return countryName;
    }

    public static long getGroupId(String countryCode) {
        for (IshaAPAC.CountryCfg cty : IshaAPAC.countryCfgs) {
            if (cty.name.equalsIgnoreCase(countryCode) || cty.shortName.equalsIgnoreCase(countryCode)) {
                return cty.groupId;
            }
        }
        return defaultGroupId;
    }

}
