package crmdna.client.isha;

import crmdna.client.isha.ieo.IshaIEO;
import crmdna.client.isha.ieo.IshaIEOProfileProp;
import crmdna.common.DateUtils;
import crmdna.member.MemberProgramProp;
import crmdna.member.MemberProp;
import crmdna.programtype.ProgramType;
import crmdna.programtype.ProgramTypeProp;

import java.util.logging.Logger;

public class IshaMember {

    private final static Logger LOGGER = Logger.getLogger(IshaMember.class.getName());

    public static void updateMemberProgramProps(MemberProp memberProp) {

        if (memberProp.ieoProfileId != null) {
            MemberProgramProp memberProgramProp = new MemberProgramProp();
            IshaIEOProfileProp ieoProfileProp = IshaIEO.getIEOProfileEntity(memberProp.ieoProfileId).toProp();

            memberProgramProp.verified = true;
            memberProgramProp.groupOrCity = "Class #" + ieoProfileProp.classNumber;
            memberProgramProp.month = DateUtils.Month.JAN;
            memberProgramProp.year = 0;

            ProgramTypeProp programTypeProp = ProgramType.safeGetByIdOrName("isha", "Inner Engineering Online").toProp("isha");
            memberProgramProp.programTypeId = programTypeProp.programTypeId;
            memberProgramProp.teacher = "Online";

            memberProgramProp.programId = 0;
            memberProp.memberProgramProps.add(memberProgramProp);
        }
    }

}
