package crmdna.client.isha;

import crmdna.client.isha.ieo.IshaIEO;
import crmdna.client.isha.ieo.IshaIEOProfileEntity;
import crmdna.client.isha.ieo.IshaIEOProfileProp;
import crmdna.mail2.MailMap;
import crmdna.program.Program;
import crmdna.program.ProgramProp;
import crmdna.registration.Registration;
import crmdna.registration.RegistrationProp;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.net.HttpURLConnection;
import java.net.URL;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.logging.Logger;

public class IshaRegistration {

    private final static Logger LOGGER = Logger.getLogger(IshaRegistration.class.getName());

    public static void handlePostRegistration(RegistrationProp registrationProp) throws Exception {

        if (registrationProp.txReference == null) {
            return;
        }

        String url = "https://script.google.com/macros/s/AKfycbxLH3VL_HzW_4VVzQbUf_Mr5dFYAuDwn0jI7h0IfmlQyd-NjoA/exec";

        HttpURLConnection conn = (HttpURLConnection) (new URL(url)).openConnection();
        conn.setInstanceFollowRedirects(true);
        conn.setConnectTimeout(30000);
        conn.setReadTimeout(30000);
        conn.setRequestMethod("POST");
        conn.setDoInput(true);
        conn.setDoOutput(true);

        try (OutputStream os = conn.getOutputStream()) {
            os.write(registrationProp.txReference.getBytes("UTF-8"));
        }

        try(BufferedReader in = new BufferedReader(new InputStreamReader(conn.getInputStream()))) {
            for (String line; (line = in.readLine()) != null;) {
                LOGGER.info(line);
            }
        }
    }

    public static void update(MailMap mailMap, RegistrationProp registrationProp) {
        IshaIEOProfileEntity ieoProfileEntity = IshaIEO.getIEOProfileEntityByRegId(registrationProp.registrationId);
        if (ieoProfileEntity != null) {
            IshaIEOProfileProp profileProp = ieoProfileEntity.toProp();
            mailMap.setMergeVar(registrationProp.email, MailMap.MergeVarID.VAR1, profileProp.classNumber + "");
        }
    }

    public static void updateQueryProps(List<RegistrationProp> registrationProps) {

        if (registrationProps.size() == 0) return;

        ProgramProp programProp = Program.safeGet("isha", registrationProps.get(0).programId).toProp("isha");
        if (programProp.programTypeProp.displayName.contains("Shambhavi")) {
            Map<Long, RegistrationProp> map = new HashMap<>();
            for (RegistrationProp prop : registrationProps) {
                map.put(prop.registrationId, prop);
            }

            List<IshaIEOProfileEntity> ieoProfileEntities = IshaIEO.getIEOProfileEntityByRegIds(map.keySet());
            for (IshaIEOProfileEntity ieoProfileEntity : ieoProfileEntities) {
                IshaIEOProfileProp ieoProfileProp = ieoProfileEntity.toProp();
                RegistrationProp registrationProp =  map.get(ieoProfileProp.registrationId);
                registrationProp.ieoClassNumber = ieoProfileProp.classNumber;
            }
        }
    }
}
