package crmdna.client.isha.ieo;

import com.googlecode.objectify.annotation.Cache;
import com.googlecode.objectify.annotation.Entity;
import com.googlecode.objectify.annotation.Id;
import com.googlecode.objectify.annotation.Index;
import crmdna.common.DateUtils;
import crmdna.common.contact.Contact;
import crmdna.common.contact.ContactProp;

import java.util.Date;

@Entity
@Cache
public class IshaIEOProfileEntity {
    @Id
    long id;

    @Index
    String email;

    String firstName;
    String lastName;
    String homePhone;
    String mobilePhone;
    String gender;
    String country;
    String city;
    String postalCode;

    @Index
    int classNumber;

    int completedYYYYMMDD;

    @Index
    long startMs;

    int endYYYYMMDD;
    int paymentYYYYMMDD;

    @Index
    Long registrationId;        // Filled after syncing

    String coupon;
    Long smmProgramId;          // Filled after syncing
    Boolean packageReg;         // Filled after syncing

    @Index
    long memberId;

    public IshaIEOProfileProp toProp() {
        IshaIEOProfileProp prop = new IshaIEOProfileProp();

        prop.id = id;
        prop.email = email;
        prop.firstName = firstName;
        prop.lastName = lastName;
        prop.homePhone = homePhone;
        prop.mobilePhone = mobilePhone;
        prop.gender = gender;
        prop.country = country;
        prop.city = city;
        prop.postalCode = postalCode;

        prop.classNumber = classNumber;

        prop.completedYYYYMMDD = completedYYYYMMDD;
        prop.startMs = startMs;
        prop.endYYYYMMDD = endYYYYMMDD;
        prop.paymentYYYYMMDD = paymentYYYYMMDD;
        prop.coupon = coupon;

        prop.memberId = memberId;
        prop.registrationId = registrationId;
        prop.smmProgramId = smmProgramId;

        return prop;
    }

    public ContactProp getContactProp() {
        ContactProp contactProp = new ContactProp();
        contactProp.email = email;
        contactProp.firstName = firstName;
        contactProp.lastName = lastName;
        contactProp.homePhone = homePhone;
        contactProp.mobilePhone = mobilePhone;
        contactProp.gender = Contact.getGender(gender);
        contactProp.asOfyyyymmdd = DateUtils.toYYYYMMDD(new Date());
        contactProp.homeAddress.country = country;
        contactProp.homeAddress.city = city;
        contactProp.homeAddress.pincode = postalCode;

        return contactProp;
    }

    public long getId() {
        return id;
    }

    public long getMemberId() {
        return memberId;
    }
}
