package crmdna.programtype;

import java.util.HashSet;
import java.util.Map;
import java.util.Set;

public class ProgramTypeHelper {
    public static void populateName(String client,
                                    Iterable<? extends IHasProgramTypeIdAndName> iterable) {

        // do a batch get using ids and populate names
        Set<Long> ids = new HashSet<>();
        for (IHasProgramTypeIdAndName element : iterable) {
            ids.add(element.getProgramTypeId());
        }

        Map<Long, ProgramTypeEntity> map = ProgramType.getEntities(client, ids);

        for (IHasProgramTypeIdAndName element : iterable) {

            long id = element.getProgramTypeId();

            if (!map.containsKey(id))
                continue;

            String name = map.get(id).displayName;
            element.setProgramTypeName(name);
        }
    }

    public static void populateNames(String client,
        Iterable<? extends IHasProgramTypeIdAndNames> iterable, boolean noShow) {

        Set<Long> ids = new HashSet<>();
        for (IHasProgramTypeIdAndNames element : iterable) {
            ids.addAll(element.getProgramTypeIds(noShow));
        }

        Map<Long, ProgramTypeEntity> map = ProgramType.getEntities(client, ids);

        for (IHasProgramTypeIdAndNames element : iterable) {

            Set<String> names = new HashSet<>();
            for (Long id : element.getProgramTypeIds(noShow)) {
                if (!map.containsKey(id))
                    continue;

                names.add(map.get(id).displayName);
            }
            element.setProgramTypeNames(noShow, names);
        }
    }
}
